﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
'#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private Panel1 As B4XView
	Private EditText1 As B4XView
End Sub

Public Sub Initialize
	
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	B4XPages.SetTitle(Me, "B4X Bubble")
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.

Public Sub TextBubble(inPanel As B4XView, inTexts() As String, inFontSize As Float)

	For Each v As B4XView In inPanel.GetAllViewsRecursive
		v.RemoveViewFromParent
	Next
    
	If inTexts.Length = 0 Then Return
    
	Dim Border As Float  = 0dip 'StrokeWidth
	Dim Edge As Float = 15dip 'Distance
	Dim cvs As B4XCanvas

	cvs.Initialize(inPanel)

    #region measure text size

	Dim width, height As Float
	width = 0
	height = 0

	Dim FontHeight As Float
	FontHeight = 1dip

	For Each t As String In inTexts
		FontHeight = Max(FontHeight , cvs.MeasureText(t, xui.CreateDefaultFont(DipToCurrent(inFontSize))).Height + 1dip) 'max. text row height
	Next

	For Each t As String In inTexts
		width = Max(width , cvs.MeasureText(t, xui.CreateDefaultFont(DipToCurrent(inFontSize))).Width) 'maximal with
		height = height + FontHeight
	Next

    #end region

    #region bubble

	'make it bigger for the border around

	Dim width2, height2 As Float
    
	width2 = width + Edge * 2.0
	height2 = height + Edge * 2.0
    
	Dim Rect1 As B4XRect
	Rect1.Initialize(inPanel.Width / 2.0 - width2 / 2.0  , inPanel.Height / 2.0  - height2 / 2.0,  inPanel.Width / 2.0 + width2 / 2.0, inPanel.Height / 2.0 + height2 / 2.0)
            
	Dim Path1 As B4XPath
	Path1.Initialize(Rect1.Left + Edge, Rect1.Top)
	Path1.LineTo(Rect1.Right ,Rect1.Top)
	Path1.LineTo(Rect1.Right ,Rect1.Bottom)

	Path1.LineTo(Rect1.Right - Rect1.Width * 0.5,  Rect1.Bottom)
	Path1.LineTo(Rect1.Right - Rect1.Width * 0.5,  Rect1.Bottom + Edge * 3.0) 'peak
	Path1.LineTo(Rect1.Right - Rect1.Width * 0.75, Rect1.Bottom)

	Path1.LineTo(Rect1.Left ,Rect1.Bottom)
	Path1.LineTo(Rect1.Left ,Rect1.Top + Edge)

	'math corner left, top
	Dim a As Float,x As Float,y As Float
    
	For a = 0.0 To 90.0 Step 10.0
		x = -CosD(a) * Edge
		y = -SinD(a) * Edge
		Path1.LineTo(Rect1.Left + Edge + x ,Rect1.Top + Edge + y)
	Next

	cvs.DrawPath(Path1, xui.Color_RGB(0,128,0), True, 1)
	cvs.DrawPath(Path1, xui.Color_White, False, Border)

    #end region

    #region draw text

	Dim Rect1 As B4XRect
    
	Rect1.Initialize(inPanel.Width / 2.0 -width / 2.0, inPanel.Height / 2.0 - height / 2.0,  inPanel.Width / 2.0 + width / 2.0, inPanel.Height / 2.0 + height / 2.0)

	'test rect
	'    cvs.DrawRect( Rect1, XUI.Color_Black, False, 1dip) 'check size
    
	Dim y As Float = Rect1.Top
	Dim h As Float = 0
    
	For Each t As String In inTexts
		h = FontHeight
		y = y + h
		cvs.DrawText(t, Rect1.Left, y - FontHeight * 0.1, xui.CreateDefaultFont(inFontSize), xui.Color_Yellow, "LEFT")
	Next

	cvs.Invalidate
    #end region
End Sub

Public Sub SplitRows(Text1 As String) As String()
	Text1=Text1.Replace(Chr(13),"")
	Dim response() As String
	response = Regex.Split("\" & Chr(10) , Text1) ' \ is escape character
	Return response
End Sub

Sub EditText1_EnterPressed   'did not work in multiline
	'Update
	TextBubble(Panel1,SplitRows(EditText1.Text),28)
End Sub

Sub EditText1_TextChanged (Old As String, New As String)
	'Update
	TextBubble(Panel1,SplitRows(New),28)
End Sub

Private Sub EditText1_FocusChanged (HasFocus As Boolean)
	'Update
	TextBubble(Panel1,SplitRows(EditText1.Text),28)
End Sub